<?php

class p_visitor extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        //   

        $this->info['plugin']           = 'p_visitor';
        $this->info['title']            = ' ';
        $this->info['description']      = '  ""    ';
        $this->info['author']           = 'RoViX';
        $this->info['version']          = '1.2';

        $this->info['tab']              = ''; //--    

        //  -
        $this->config[' '] = 10;
        $this->config['  '] = 0;
        $this->config['  (0-/1-)'] = 0;



        // ,    

        $this->events[]                 = 'USER_PROFILE';

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){
		global $inDB;
		$sql="CREATE TABLE IF NOT EXISTS `cms_user_profile_visitor` (
			`user_id` int(11) NOT NULL,
			`visitor_id` int(11) NOT NULL,
			`visitdate` datetime NOT NULL default '0000-00-00 00:00:00',
			INDEX ( `user_id` , `visitor_id` )
			)ENGINE=MyISAM DEFAULT CHARSET=cp1251";
		$inDB->query($sql);

		return parent::install();
    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     *  
     * @param string $event
     * @param array $user
     * @return html
     */
public function execute($event, $user){

	parent::execute();

	$articles   = array();

	$user_id    = $user['id'];
	if ( $user_id == cmsUserId() ) {
		$limit = isset($this->config[' ']) ? $this->config[' '] : 20;

		$num_col = $this->config['  (0-/1-)'];
		if ( !$num_col == 0 && !$num_col == 1) { $num_col = 0; }

		$only_last_visit = $this->config['  '];
		if ( !$only_last_visit == 0 && !$only_last_visit == 1) { $only_last_visit = 0; }

		$inCore = cmsCore::getInstance();
		$inDB = cmsDatabase::getInstance();

		if ( $only_last_visit == 0 ) {
			$sql =  "SELECT u.nickname, u.login, p.imageurl, v.visitdate
					FROM cms_user_profile_visitor as v, cms_users as u, cms_user_profiles as p
					WHERE v.visitor_id = u.id AND p.user_id = u.id AND v.user_id = {$user_id}
					ORDER by visitdate DESC
					LIMIT {$limit}";
		} else {
			$sql =  "SELECT distinct u.login, u.nickname, p.imageurl, max(v.visitdate) as visitdate
				FROM cms_user_profile_visitor as v, cms_users as u, cms_user_profiles as p
				WHERE v.visitor_id = u.id AND p.user_id = u.id AND v.user_id = {$user_id}
				GROUP by u.login
				ORDER by visitdate DESC
				LIMIT {$limit}";
		}
		$result     = $inDB->query($sql);
		$total      = $inDB->num_rows($result);

		if ($total){
			while ($visitor  = $this->inDB->fetch_assoc($result)){
				$visitors[] = $visitor;
			}

			if ( $total == $limit ) {
				$title = "   ( $limit .):";
			}else{
				$title = "  :";
			}
		}

		ob_start();

		if ( $num_col >= 1) { $templates = 'p_visitor_tbl.tpl';} else { $templates = 'p_visitor.tpl'; }
		$smarty= $this->inCore->initSmarty('plugins', $templates);
		$smarty->assign('total', $total);
		$smarty->assign('visitors', $visitors);
		$smarty->assign('title', $title);
		if ( $num_col >= 1) { $smarty->assign('num_col', $num_col);}
		$smarty->display($templates);

		$html = ob_get_clean();
	}
	return $html;

}

// ==================================================================== //

}

?>
